Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3569)
@@ -3071,8 +3363,8 @@
     REAL(wp) ::  tcl        !< Clothing temperature                 (Â°C)
     REAL(wp) ::  wetsk      !< Fraction of wet skin                 (factor)
-
+!
 !-- Variables:
     REAL(wp) :: int_heat    !< Internal heat        (W)
-
+!
 !-- MEMI configuration
     REAL(wp) :: age         !< Persons age          (a)
@@ -3085,5 +3377,5 @@
 !     INTEGER(iwp) :: pos     !< Posture: 1 = standing, 2 = sitting
 !     INTEGER(iwp) :: sex     !< Sex: 1 = male, 2 = female
-
+!
 !-- Configuration, keep standard parameters!
     age   = 35._wp
@@ -3094,5 +3386,5 @@
     clo   =  0.9_wp
     fcl   =  1.15_wp
-
+!
 !-- Call subfunctions
     CALL in_body ( age, eta, ere, erel, ht, int_heat, mbody, pair, rtv, ta,    &
@@ -3103,6 +3395,6 @@
             vpts, wetsk )
 
-    CALL pet_iteration ( acl, adu, aeff, esw, facl, feff, int_heat, pair, rdcl,&
-            rdsk, rtv, ta, tcl, tsk, pet, vpts, wetsk )
+    CALL pet_iteration ( acl, adu, aeff, esw, facl, feff, int_heat, pair,      &
+            rdcl, rdsk, rtv, ta, tcl, tsk, pet_ij, vpts, wetsk )
 
 
@@ -3117,5 +3409,5 @@
  SUBROUTINE in_body ( age, eta, ere, erel, ht, int_heat, mbody, pair, rtv, ta, &
     vpa, work )
-
+!
 !-- Input arguments:
     REAL(wp), INTENT( IN )  ::  pair      !< air pressure             (hPa)
@@ -3127,5 +3419,5 @@
     REAL(wp), INTENT( IN )  ::  work      !< Work load                (W)
     REAL(wp), INTENT( IN )  ::  eta       !< Work efficiency      (dimensionless)
-
+!
 !-- Output arguments:
     REAL(wp), INTENT( OUT ) ::  ere       !< energy ballance          (W)
@@ -3133,9 +3425,9 @@
     REAL(wp), INTENT( OUT ) ::  int_heat  !< internal heat production (W)
     REAL(wp), INTENT( OUT ) ::  rtv       !< respiratory volume
-
+!
 !-- Constants:
 !     REAL(wp), PARAMETER :: cair = 1010._wp        !< replaced by c_p
 !     REAL(wp), PARAMETER :: evap = 2.42_wp * 10._wp **6._wp  !< replaced by l_v
-
+!
 !-- Internal variables:
     REAL(wp) ::  eres                     !< Sensible respiratory heat flux (W)
@@ -3151,14 +3443,14 @@
 
     int_heat = met * (1._wp - eta)
-
+!
 !-- Sensible respiration energy
     tex  = 0.47_wp * ta + 21.0_wp
     rtv  = 1.44_wp * 10._wp ** (-6._wp) * met
     eres = c_p * (ta - tex) * rtv
-
+!
 !-- Latent respiration energy
     vpex = 6.11_wp * 10._wp ** ( 7.45_wp * tex / ( 235._wp + tex ) )
     erel = 0.623_wp * l_v / pair * ( vpa - vpex ) * rtv
-
+!
 !-- Sum of the results
     ere = eres + erel
@@ -3176,5 +3468,5 @@
         vpts, wetsk )
 
-
+!
 !-- Input arguments:
     REAL(wp), INTENT( IN )  ::  ere    !< Energy ballance          (W)
@@ -3190,5 +3482,5 @@
     REAL(wp), INTENT( IN )  ::  clo    !< clothing insulation      (clo)
     REAL(wp), INTENT( IN )  ::  fcl    !< factor for surface area increase by clothing
-
+!
 !-- Output arguments:
     REAL(wp), INTENT( OUT ) ::  acl    !< Clothing surface area        (mÂ²)
@@ -3204,5 +3496,5 @@
     REAL(wp), INTENT( OUT ) ::  vpts   !< Sat. vapor pressure over skin (hPa)
     REAL(wp), INTENT( OUT ) ::  wetsk  !< Fraction of wet skin (dimensionless)
-
+!
 !-- Cconstants:
 !     REAL(wp), PARAMETER :: cair = 1010._wp      !< replaced by c_p
@@ -3214,5 +3506,5 @@
     REAL(wp), PARAMETER :: po   = 1013.25_wp      !< Air pressure at sea level (hPa)
     REAL(wp), PARAMETER :: rob  =    1.06_wp      !< 
-
+!
 !-- Internal variables
     REAL(wp) ::  c(0:10)        !< Core temperature array           (Â°C)
@@ -3239,5 +3531,5 @@
     REAL(wp) ::  rsum           !< Radiational loss or gain         (W/mÂ²)
     REAL(wp) ::  sw             !< 
-    REAL(wp) ::  swf            !< 
+!     REAL(wp) ::  swf            !< female factor, currently unused
     REAL(wp) ::  swm            !< 
     REAL(wp) ::  tbody          !< 
@@ -3279,5 +3571,5 @@
 
     di   = r2 - r1
-
+!
 !-- Skin temperatur
     DO j = 1, 7
@@ -3295,5 +3587,5 @@
           htcl  = 6.28_wp * ht * y * di / ( rcl * LOG( r2 / r1 ) * acl )
           tsk   = 1._wp / htcl * ( hc * ( tcl - ta ) + rclo2 ) + tcl
-
+!
 !--       Radiation saldo
           aeff  = adu * feff
@@ -3303,10 +3595,10 @@
             ( ( tmrt + degc_to_k )** 4._wp - ( tcl + degc_to_k )** 4._wp )
           rsum  = rbare + rclo
-
+!
 !--       Convection
           cbare = hc * ( ta - tsk ) * adu * ( 1._wp - facl )
           cclo  = hc * ( ta - tcl ) * acl
           csum  = cbare + cclo
-
+!
 !--       Core temperature
           c(0)  = int_heat + ere
@@ -3337,5 +3629,5 @@
              tcore(4) = c(0) / ( 5.28_wp * adu + c(1) * 1._wp / 40._wp ) + tsk
           END IF
-
+!
 !--       Transpiration
           tbody = 0.1_wp * tsk + 0.9_wp * tcore(j)
@@ -3360,5 +3652,5 @@
           IF ( eswdif > 0._wp ) esw = eswphy   !< Limit is sweat production
           IF ( esw  > 0._wp )   esw = 0._wp    !< Sweat can't be evaporated, no more cooling effect
-
+!
 !--       Diffusion
           rdsk = 0.79_wp * 10._wp ** 7._wp
@@ -3366,5 +3658,5 @@
           ed   = l_v / ( rdsk + rdcl ) * adu * ( 1._wp - wetsk ) * ( vpa -     &
              vpts )
-
+!
 !--       Max vb
           vb1 = 34._wp - tsk
@@ -3374,8 +3666,8 @@
           IF ( vb1 < 0._wp ) vb1 = 0._wp
           vb = ( 6.3_wp + 75._wp * vb2 ) / ( 1._wp + 0.5_wp * vb1 )
-
+!
 !--       Energy ballence
           enbal = int_heat + ed + ere + esw + csum + rsum + food
-
+!
 !--       Clothing temperature
           xx = 0.001_wp
@@ -3429,5 +3721,5 @@
        IF ( ( j == 4_iwp ) .AND. ( vb < 89._wp ) ) CYCLE
        IF ( vb > 90._wp ) vb = 90._wp
-
+!
 !--    Loses by water
        ws = sw * 3600._wp * 1000._wp
@@ -3448,6 +3740,6 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE pet_iteration ( acl, adu, aeff, esw, facl, feff, int_heat, pair,   &
-        rdcl, rdsk, rtv, ta, tcl, tsk, pet, vpts, wetsk )
-
+        rdcl, rdsk, rtv, ta, tcl, tsk, pet_ij, vpts, wetsk )
+!
 !-- Input arguments:
     REAL(wp), INTENT( IN ) ::  acl   !< clothing surface area        (mÂ²)
@@ -3466,16 +3758,14 @@
     REAL(wp), INTENT( IN ) ::  vpts  !< sat. vapor pressure over skin (hPa)
     REAL(wp), INTENT( IN ) ::  wetsk !< fraction of wet skin (dimensionless)
-
+!
 !-- Output arguments:
-    REAL(wp), INTENT( OUT ) ::  aeff  !< effective surface area       (mÂ²)
-    REAL(wp), INTENT( OUT ) ::  pet   !< PET                          (Â°C)
-
+    REAL(wp), INTENT( OUT ) ::  aeff     !< effective surface area       (mÂ²)
+    REAL(wp), INTENT( OUT ) ::  pet_ij   !< PET                          (Â°C)
+!
 !-- Cconstants:
-!     REAL(wp), PARAMETER :: cair = 1010._wp        !< replaced by c_p
     REAL(wp), PARAMETER :: emcl =    0.95_wp      !< Longwave emission coef. of cloth
     REAL(wp), PARAMETER :: emsk =    0.99_wp      !< Longwave emission coef. of skin
-!     REAL(wp), PARAMETER :: evap = 2.42_wp * 10._wp **6._wp  !< replaced by l_v
     REAL(wp), PARAMETER :: po   = 1013.25_wp      !< Air pressure at sea level (hPa)
-
+!
 !-- Internal variables
     REAL ( wp ) ::  cbare             !< Convection through bare skin
@@ -3499,5 +3789,5 @@
     INTEGER ( iwp ) ::  i             !< running index
 
-    pet = ta
+    pet_ij = ta
     enbal2 = 0._wp
 
@@ -3506,39 +3796,40 @@
           hc = 2.67_wp + 6.5_wp * 0.1_wp ** 0.67_wp
           hc = hc * ( pair / po ) ** 0.55_wp
-
+!
 !--       Radiation
           aeff  = adu * feff
           rbare = aeff * ( 1._wp - facl ) * emsk * sigma_sb *                  &
-              ( ( pet + degc_to_k ) ** 4._wp - ( tsk + degc_to_k ) ** 4._wp )
+              ( ( pet_ij + degc_to_k ) ** 4._wp - ( tsk + degc_to_k ) ** 4._wp )
           rclo  = feff * acl * emcl * sigma_sb *                               &
-              ( ( pet + degc_to_k ) ** 4._wp - ( tcl + degc_to_k ) ** 4._wp )
+              ( ( pet_ij + degc_to_k ) ** 4._wp - ( tcl + degc_to_k ) ** 4._wp )
           rsum  = rbare + rclo
-
+!
 !--       Covection
-          cbare = hc * ( pet - tsk ) * adu * ( 1._wp - facl )
-          cclo  = hc * ( pet - tcl ) * acl
+          cbare = hc * ( pet_ij - tsk ) * adu * ( 1._wp - facl )
+          cclo  = hc * ( pet_ij - tcl ) * acl
           csum  = cbare + cclo
-
+!
 !--       Diffusion
           ed = l_v / ( rdsk + rdcl ) * adu * ( 1._wp - wetsk ) * ( 12._wp -    &
              vpts )
-
+!
 !--       Respiration
-          tex  = 0.47_wp * pet + 21._wp
-          eres = c_p * ( pet - tex ) * rtv
+          tex  = 0.47_wp * pet_ij + 21._wp
+          eres = c_p * ( pet_ij - tex ) * rtv
           vpex = 6.11_wp * 10._wp ** ( 7.45_wp * tex / ( 235._wp + tex ) )
           erel = 0.623_wp * l_v / pair * ( 12._wp - vpex ) * rtv
           ere  = eres + erel
-
+!
 !--       Energy ballance
           enbal = int_heat + ed + ere + esw + csum + rsum
-
+!
 !--       Iteration concerning ta
+          xx = 0.001_wp
           IF ( count1 == 0_iwp )  xx = 1._wp
           IF ( count1 == 1_iwp )  xx = 0.1_wp
           IF ( count1 == 2_iwp )  xx = 0.01_wp
-          IF ( count1 == 3_iwp )  xx = 0.001_wp
-          IF ( enbal > 0._wp )  pet = pet - xx
-          IF ( enbal < 0._wp )  pet = pet + xx
+!           IF ( count1 == 3_iwp )  xx = 0.001_wp
+          IF ( enbal > 0._wp )  pet_ij = pet_ij - xx
+          IF ( enbal < 0._wp )  pet_ij = pet_ij + xx
           IF ( ( enbal <= 0._wp ) .AND. ( enbal2 > 0._wp ) ) EXIT
           IF ( ( enbal >= 0._wp ) .AND. ( enbal2 < 0._wp ) ) EXIT
@@ -3549,4 +3840,232 @@
  END SUBROUTINE pet_iteration
 
+!
+!-- UVEM specific subroutines
+
+!---------------------------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Module-specific routine for new module
+!---------------------------------------------------------------------------------------------------------------------!
+ SUBROUTINE uvem_solar_position
+    
+    USE date_and_time_mod,                                                                                            &
+       ONLY:  calc_date_and_time, day_of_year, time_utc 
+    
+    USE control_parameters,                                                                                           &
+       ONLY:  latitude, longitude   
+
+    IMPLICIT NONE
+    
+   
+    REAL(wp) ::  alpha       = 0.0_wp   !< solar azimuth angle in radiant    
+    REAL(wp) ::  doy_r       = 0.0_wp   !< real format of day_of_year           
+    REAL(wp) ::  declination = 0.0_wp   !< declination
+    REAL(wp) ::  dtor        = 0.0_wp   !< factor to convert degree to radiant
+    REAL(wp) ::  js          = 0.0_wp   !< parameter for solar position calculation
+    REAL(wp) ::  lat         = 52.39_wp !< latitude
+    REAL(wp) ::  lon         = 9.7_wp   !< longitude        
+    REAL(wp) ::  thetar      = 0.0_wp   !< angle for solar zenith angle calculation
+    REAL(wp) ::  thetasr     = 0.0_wp   !< angle for solar azimuth angle calculation    
+    REAL(wp) ::  zgl         = 0.0_wp   !< calculated exposure by direct beam   
+    REAL(wp) ::  woz         = 0.0_wp   !< calculated exposure by diffuse radiation
+    REAL(wp) ::  wsp         = 0.0_wp   !< calculated exposure by direct beam   
+   
+
+    CALL calc_date_and_time
+    doy_r = real(day_of_year)   
+    dtor = pi / 180.0_wp
+    lat = latitude
+    lon = longitude
+!
+!-- calculation of js, necessary for calculation of equation of time (zgl) :
+    js=  72.0_wp * ( doy_r + ( time_utc / 86400.0_wp ) ) / 73.0_wp 
+!
+!-- calculation of equation of time (zgl):
+    zgl = 0.0066_wp + 7.3525_wp * cos( ( js + 85.9_wp ) * dtor ) + 9.9359_wp *                                        &
+    cos( ( 2.0_wp * js + 108.9_wp ) * dtor ) + 0.3387_wp * cos( ( 3 * js + 105.2_wp ) * dtor )
+!
+!-- calculation of apparent solar time woz:
+    woz = ( ( time_utc / 3600.0_wp ) - ( 4.0_wp * ( 15.0_wp - lon ) ) / 60.0_wp ) + ( zgl / 60.0_wp )
+!
+!-- calculation of hour angle (wsp):
+    wsp = ( woz - 12.0_wp ) * 15.0_wp
+!
+!-- calculation of declination:
+    declination = 0.3948_wp - 23.2559_wp * cos( ( js + 9.1_wp ) * dtor ) -                                            &
+    0.3915_wp * cos( ( 2.0_wp * js + 5.4_wp ) * dtor ) - 0.1764_wp * cos( ( 3.0_wp * js + 26.0_wp ) * dtor )
+!
+!-- calculation of solar zenith angle
+    thetar  = acos( sin( lat * dtor) * sin( declination * dtor ) + cos( wsp * dtor ) *                                &
+    cos( lat * dtor ) * cos( declination * dtor ) )
+    thetasr = asin( sin( lat * dtor) * sin( declination * dtor ) + cos( wsp * dtor ) *                                & 
+    cos( lat * dtor ) * cos( declination * dtor ) )
+    sza = thetar / dtor
+!
+!-- calculation of solar azimuth angle
+    IF (woz .LE. 12.0_wp) alpha = pi - acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
+    sin( declination * dtor ) ) / ( cos(thetasr) * cos( lat * dtor ) ) )    
+    IF (woz .GT. 12.0_wp) alpha = pi + acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
+    sin( declination * dtor ) ) / ( cos(thetasr) * cos( lat * dtor ) ) )    
+    saa = alpha / dtor
+
+ END SUBROUTINE uvem_solar_position
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Module-specific routine for new module
+!---------------------------------------------------------------------------------------------------------------------!
+ SUBROUTINE uvem_calc_exposure
+
+    USE indices,                                                                                                      &
+        ONLY:  nxlg, nxrg, nyng, nysg, nys, nyn, nxl, nxr 
+    
+    
+    IMPLICIT NONE   
+    
+    INTEGER(iwp) ::  i     !< loop index in x direction
+    INTEGER(iwp) ::  j     !< loop index in y direction
+    INTEGER(iwp) ::  szai  !< loop index for different sza values
+
+    CALL uvem_solar_position
+     
+    IF (sza  .GE.  90) THEN
+       vitd3_exposure(:,:) = 0.0_wp
+    ELSE
+       
+       DO  ai = 0, 35
+          DO  zi = 0, 9
+                projection_area_lookup_table(ai,zi) = uvem_projarea_f%var(clothing,zi,ai)
+          ENDDO
+       ENDDO
+       DO  ai = 0, 35
+          DO  zi = 0, 9
+                integration_array(ai,zi) = uvem_integration_f%var(zi,ai)
+          ENDDO
+       ENDDO
+       DO  ai = 0, 2
+          DO  zi = 0, 90
+                irradiance_lookup_table(ai,zi) = uvem_irradiance_f%var(zi,ai)
+          ENDDO
+       ENDDO
+       DO  ai = 0, 35
+          DO  zi = 0, 9
+             DO  szai = 0, 90
+                radiance_lookup_table(ai,zi,szai) = uvem_radiance_f%var(szai,zi,ai)
+             ENDDO
+          ENDDO
+       ENDDO
+        
+        
+        
+!--    rotate 3D-Model human to desired direction  ----------------------------- 
+       projection_area_temp( 0:35,:) = projection_area_lookup_table
+       projection_area_temp(36:71,:) = projection_area_lookup_table               
+       IF (  .NOT.  turn_to_sun ) startpos_human = orientation_angle / 10.0_wp
+       IF (       turn_to_sun ) startpos_human = saa / 10.0_wp        
+       DO  ai = 0, 35
+          xfactor = ( startpos_human ) - INT( startpos_human )
+          DO  zi = 0, 9
+             projection_area(ai,zi) = ( projection_area_temp( 36 - INT( startpos_human ) - 1 + ai , zi) *             &
+                                      ( xfactor ) )                                                                   &
+                                      +( projection_area_temp( 36 - INT( startpos_human ) + ai , zi) *                &
+                                      ( 1.0_wp - xfactor ) )
+          ENDDO
+       ENDDO           
+!             
+!           
+!--    interpolate to accurate Solar Zenith Angle  ------------------          
+       DO  ai = 0, 35
+          xfactor = (sza)-INT(sza)
+          DO  zi = 0, 9
+             radiance_array(ai,zi) = ( radiance_lookup_table(ai, zi, INT(sza) ) * ( 1.0_wp - xfactor) ) +             &
+             ( radiance_lookup_table(ai,zi,INT(sza) + 1) * xfactor )
+          ENDDO
+       ENDDO
+       DO  iq = 0, 2
+          irradiance(iq) = ( irradiance_lookup_table(iq, INT(sza) ) * ( 1.0_wp - xfactor)) +                          &
+          (irradiance_lookup_table(iq, INT(sza) + 1) * xfactor )
+       ENDDO   
+!         
+!--    interpolate to accurate Solar Azimuth Angle ------------------
+       IF ( sun_in_south )  THEN
+          startpos_saa_float = 180.0_wp / 10.0_wp
+       ELSE 
+          startpos_saa_float = saa / 10.0_wp
+       ENDIF
+       radiance_array_temp( 0:35,:) = radiance_array
+       radiance_array_temp(36:71,:) = radiance_array
+       xfactor = (startpos_saa_float) - INT(startpos_saa_float)
+       DO  ai = 0, 35
+          DO  zi = 0, 9
+             radiance_array(ai,zi) = ( radiance_array_temp( 36 - INT( startpos_saa_float ) - 1 + ai , zi ) *          &
+                                     ( xfactor ) )                                                                    &
+                                     + ( radiance_array_temp( 36 - INT( startpos_saa_float ) + ai , zi )              &
+                                     * ( 1.0_wp - xfactor ) )
+          ENDDO
+       ENDDO 
+!        
+!      
+!--    calculate Projectionarea for direct beam -----------------------------'
+       projection_area_direct_temp( 0:35,:) = projection_area
+       projection_area_direct_temp(36:71,:) = projection_area
+       yfactor = ( sza / 10.0_wp ) - INT( sza / 10.0_wp )
+       xfactor = ( startpos_saa_float ) - INT( startpos_saa_float )
+       projection_area_direct_beam = ( projection_area_direct_temp( INT(startpos_saa_float)    ,INT(sza/10.0_wp)  ) * &
+                                     ( 1.0_wp - xfactor ) * ( 1.0_wp - yfactor ) ) +                                  &
+                                     ( projection_area_direct_temp( INT(startpos_saa_float) + 1,INT(sza/10.0_wp)  ) * &
+                                     (          xfactor ) * ( 1.0_wp - yfactor ) ) +                                  &
+                                     ( projection_area_direct_temp( INT(startpos_saa_float)    ,INT(sza/10.0_wp)+1) * &
+                                     ( 1.0_wp - xfactor ) * (          yfactor ) ) +                                  &
+                                     ( projection_area_direct_temp( INT(startpos_saa_float) + 1,INT(sza/10.0_wp)+1) * &
+                                     (          xfactor ) * (          yfactor ) )
+!                                                
+!                                                
+!                                                
+       DO  i = nxl, nxr    !nxlg, nxrg
+          DO  j = nys, nyn    !nysg, nyng 
+!                   
+! !--        extract obstruction from IBSET-Integer_Array ------------------'
+             IF (consider_obstructions ) THEN
+                obstruction_temp1 = building_obstruction_f%var_3d(:,j,i)
+                IF (obstruction_temp1(0)  .NE.  9) THEN 
+                   DO  pobi = 0, 44 
+                      DO  bi = 0, 7 
+                         IF ( btest( obstruction_temp1(pobi), bi )  .EQV.  .TRUE.) THEN
+                            obstruction_temp2( ( pobi * 8 ) + bi ) = 1
+                         ELSE
+                            obstruction_temp2( ( pobi * 8 ) + bi ) = 0
+                         ENDIF
+                      ENDDO
+                   ENDDO        
+                   DO  zi = 0, 9                                          
+                      obstruction(:,zi) = obstruction_temp2( zi * 36 :( zi * 36) + 35 )
+                   ENDDO
+                ELSE 
+                   obstruction(:,:) = 0
+                ENDIF
+             ENDIF
+!              
+! !--        calculated human exposure ------------------'  
+             diffuse_exposure = SUM( radiance_array * projection_area * integration_array * obstruction )      
+         
+             obstruction_direct_beam = obstruction( nint(startpos_saa_float), nint( sza / 10.0_wp ) ) 
+             IF (sza  .GE.  89.99_wp) THEN
+                sza = 89.99999_wp
+             ENDIF
+!             
+!--          calculate direct normal irradiance (direct beam) ------------------'
+             direct_exposure = ( irradiance(1) / cos( pi * sza / 180.0_wp ) ) * &
+             projection_area_direct_beam * obstruction_direct_beam  
+               
+             vitd3_exposure(j,i) = ( diffuse_exposure + direct_exposure ) / 1000.0_wp * 70.97_wp 
+             ! unit = international units vitamin D per second              
+          ENDDO
+       ENDDO
+    ENDIF
+
+ END SUBROUTINE uvem_calc_exposure
 
  END MODULE biometeorology_mod
